/*
% if femdk:
 * This file is a part of FEMDK, a Finite Element Method Development Kit.
 * FEMDK provides utilities of developing simulation codes base on various 
 * variants of finite element method.
 *
 * Project web page: https://femdk.l5.pk.edu.pl/femdk
% endif
 * 
 * Copyright (c) ${year} ${owner} 
 * 
% if license == 'BSD':
 * This file is distributed on "Simplified BSD License" as approved by 
 * the OSI Board. For licensing terms see LICENSE.BSD file distributed 
 * with this file.
% endif
 */

/*
 * Author: ${author} <${email}>
 * Created: ${date}
 * Modified by:
 */

/** 
 *  FIXME : describe the purpose of this file here
 */
#include "${basename}_config.h"
#include <stdlib.h> // for EXIT_SUCCESS
%if cmdlgener == 'autoopt':
#include "${basename}_options.h" 
%endif
#include <iostream>

%if femdk:
#include "femdk/femdk_common.hxx"
#include "femdk/femdk_params.hxx"
class MyParams : public femdk::OutputParams,
                 public femdk::LoggerParams,
                 public femdk::MiscParams {
  public:
    MyParams() {}
    void setUp(void);
    void echo(std::ostream &out);
};

inline void MyParams::setUp(void) {
  femdk::OutputParams::setUp();
  femdk::LoggerParams::setUp();
  femdk::MiscParams::setUp();
}

void MyParams::echo(std::ostream &out) { 
  femdk::OutputParams::echo(out); 
  femdk::LoggerParams::echo(out);
  femdk::MiscParams::echo(out);
}

int main_body(int argc, char **argv, MyParams &options);

FEMDK_STANDARD_MAIN(MyParams, ${basename}, true);

/** The function where the main work is done after configuration
 * and command line parsing.
 */
int main_body(int argc, char **argv, MyParams &options) {
  MYLOGGER().info("Starting program ${basename}");
  int result;
  result = EXIT_SUCCESS;
  return result;
}

%else:

int main_body(int argc, char **argv);

/** main function
 * 
 * This function should contain command line parsing and initialization
 * code. The real work should be done by calling main_body().
 */
int main(int argc, char **argv) {
  int result =  EXIT_SUCCESS;
%if cmdlgener == 'autoopt':  
  {
     int optct = optionProcess(&${basename}Options, argc, argv);
     argc -= optct;
     argv += optct;
  }
  if (HAVE_OPT(DUMMY)) {
    std::cout << "Dummy option value: ";
    const char* val = OPT_ARG(DUMMY);
    std::cout << val << "\n";
  }
%endif
  result = main_body(argc, argv);

  return result;
}

/** The function where the main work is done after configuration
 * and command line parsing.
 */
int main_body(int argc, char **argv) {
  int result;
  result = EXIT_SUCCESS;
  return result;
}
%endif 
